commit aa43eeed07aca04ccb5d4fc038f9bd7002dad67e
Author: freddy77 <freddy77>
Date:   Tue Jul 8 08:47:08 2008 +0000

    remove memory leak

diff --git a/ChangeLog b/ChangeLog
index ca2836b..0f99c29 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,4 +1,7 @@
-Tue Jul 08 10:4:57 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+Tue Jul 08 10:46:04 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/pool/stream.c: remove memory leak
+
+Tue Jul 08 10:44:57 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h: add new constants for mssql2005
 
 Tue Jul 08 10:39:12 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
@@ -402,4 +405,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2547 2008/07/08 08:45:09 freddy77 Exp $
+$Id: ChangeLog,v 1.2548 2008/07/08 08:47:08 freddy77 Exp $
diff --git a/src/pool/stream.c b/src/pool/stream.c
index 8823cd9..b9a3deb 100644
--- a/src/pool/stream.c
+++ b/src/pool/stream.c
@@ -40,7 +40,7 @@
 #include "pool.h"
 #include "tds.h"
 
-TDS_RCSID(var, "$Id: stream.c,v 1.25 2007/06/19 13:31:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: stream.c,v 1.26 2008/07/08 08:47:08 freddy77 Exp $");
 
 int pool_find_end_token(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int len);
 
@@ -158,12 +158,23 @@ read_row(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *byte
 	return 1;
 }
 
+static void
+free_col_struct(struct tmp_col_struct *head)
+{
+	while (head) {
+		struct tmp_col_struct *prev = head;
+		head = prev->next;
+		free(prev->column_name);
+		free(prev);
+	}
+}
+
 static int
 read_col_name(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
 {
 	TDS_SMALLINT hdrsize;
 	int pos = 0;
-	int stop = 0, num_cols = 0;
+	int num_cols = 0;
 	int namelen;
 	struct tmp_col_struct *head = NULL, *cur = NULL, *prev;
 	int col;
@@ -175,14 +186,17 @@ read_col_name(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int
 		*bytes_read = maxlen;
 		return 0;
 	}
-	/* FIX ME -- endian */
+	/* FIXME -- endian */
 	hdrsize = buf[1] + buf[2] * 256;
 	pos += 3;
 
-	while (!stop) {
+	for (;;) {
 		prev = cur;
 		cur = (struct tmp_col_struct *)
 			malloc(sizeof(struct tmp_col_struct));
+		cur->next = NULL;
+		cur->column_name = NULL;
+
 		if (prev)
 			prev->next = cur;
 		if (!head)
@@ -190,6 +204,7 @@ read_col_name(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int
 
 		if (bytes_left(pmbr, buf, pos, maxlen, 1)) {
 			*bytes_read = maxlen;
+			free_col_struct(head);
 			return 0;
 		}
 		namelen = buf[pos++];
@@ -197,19 +212,19 @@ read_col_name(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int
 
 		if (bytes_left(pmbr, buf, pos, maxlen, namelen)) {
 			*bytes_read = maxlen;
+			free_col_struct(head);
 			return 0;
 		}
 		cur->column_name = (char *) malloc(namelen + 1);
 		strncpy(cur->column_name, (char *) &buf[pos], namelen);
 		cur->column_name[namelen] = '\0';
-		cur->next = NULL;
 
 		pos += namelen;
 
 		num_cols++;
 
 		if (pos >= hdrsize)
-			stop = 1;
+			break;
 	}
 
 	tds_free_all_results(pmbr->tds);

